'****************************************************************
'*  Name    : DeclareLocalsVars.inc                             *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 22/07/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : Local Variables for libraries or subroutines      *
'*          : Maximum 8 local variables (could be changed)      *
'****************************************************************
'
' Version 1.1 01/07/2017 Added more local variables
' Version 1.2 17/08/2017 Added more localFloat variables
'===============================================================================
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.

' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' aprci.
'===============================================================================
(* 
 RULES:
1- The local Variables could be a Bit, Byte, Word, Dword, SByte, SWord, SDword or Float.
2- The local variable name must never be repeated.
3- The local variables must be written before Macros or subroutines.
4- The local variable must be used once.
5- If the variable is used in 2 or more subroutines it is a global variable.
6- The local variable uses a system variable because the acces is more faster for Macros or Subroutines.
7- In the main code use the SM local standard variables (not System).
8- The macros can declare 8 variables only. If more variable are needed then you
   can modify the macro.

 Definition of local System Variables.
    Example:
    LocalByte0(NumberChars)
    LocalByte1(NumberCR)
    LocalByte2(Data)    

    LocalWord0(MyValue)
    LocalWord1(MyResult)
    LocalWord2(MyData)  

 Definition of local NO System Variables.
    Example:
    SMLocalByte0(NumberChars)
    SMLocalByte1(NumberCR)
    SMLocalByte2(Data)    

    SMLocalWord0(MyValue)
    SMLocalWord1(MyResult)
    SMLocalWord2(MyData) 
        
 To make more eficient the code, it is possible to declare the variable like this.
 Usually it is for a library code.
 The EEPAddress variable is for the Ewrite/Eread command.
 
    $if _eeprom > 256
    LocalWord0(EEPAddress)
    $else
    LocalByte0(EEPAddress)   
    $endif

 It could be for the main code:
    $if _eeprom > 256
    SMLocalWord0(EEPAddress)
    $else
    SMLocalByte0(EEPAddress)   
    $endif

OR
    $if _eeprom > 256
    Dim EEPAddress As Word
    $else
    Dim EEPAddress As Byte  
    $endif
    
*)
'===============================================================================
$ifndef _DeclareLocalsInc_
$define _DeclareLocalsInc_
'===============================================================================
' Declare Local Bytes Variables System
$define LocalByte0(pVar)         '
    $ifndef _LVS_Byte0           '
    $define _LVS_Byte0           '
    Dim LVS_Byte0 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte0
                          
$define LocalByte1(pVar)         '
    $ifndef _LVS_Byte1           '
    $define _LVS_Byte1           '
    Dim LVS_Byte1 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte1
    
$define LocalByte2(pVar)         '
    $ifndef _LVS_Byte2           '
    $define _LVS_Byte2           '
    Dim LVS_Byte2 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte2
    
$define LocalByte3(pVar)         '
    $ifndef _LVS_Byte3           '
    $define _LVS_Byte3           '
    Dim LVS_Byte3 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte3
    
$define LocalByte4(pVar)         '
    $ifndef _LVS_Byte4           '
    $define _LVS_Byte4           '
    Dim LVS_Byte4 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte4    
        
$define LocalByte5(pVar)         '
    $ifndef _LVS_Byte5           '
    $define _LVS_Byte5           '
    Dim LVS_Byte5 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte5
    
$define LocalByte6(pVar)         '
    $ifndef _LVS_Byte6           '
    $define _LVS_Byte6           '
    Dim LVS_Byte6 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte6            
    
$define LocalByte7(pVar)         '
    $ifndef _LVS_Byte7           '
    $define _LVS_Byte7           '
    Dim LVS_Byte7 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte7

$define LocalByte8(pVar)         '
    $ifndef _LVS_Byte8           '
    $define _LVS_Byte8           '
    Dim LVS_Byte8 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte8

$define LocalByte9(pVar)         '
    $ifndef _LVS_Byte9           '
    $define _LVS_Byte9           '
    Dim LVS_Byte9 As Byte System '
    $endif                       '
    Dim pVar As LVS_Byte9
    
$define LocalByte10(pVar)         '
    $ifndef _LVS_Byte10           '
    $define _LVS_Byte10           '
    Dim LVS_Byte10 As Byte System '
    $endif                        '
    Dim pVar As LVS_Byte10    

$define LocalByte11(pVar)         '
    $ifndef _LVS_Byte11           '
    $define _LVS_Byte11           '
    Dim LVS_Byte11 As Byte System '
    $endif                        '
    Dim pVar As LVS_Byte11   

$define LocalByte12(pVar)         '
    $ifndef _LVS_Byte12           '
    $define _LVS_Byte12           '
    Dim LVS_Byte12 As Byte System '
    $endif                        '
    Dim pVar As LVS_Byte12   
    
$define LocalByte13(pVar)         '
    $ifndef _LVS_Byte13           '
    $define _LVS_Byte13           '
    Dim LVS_Byte13 As Byte System '
    $endif                        '
    Dim pVar As LVS_Byte13       

$define LocalByte14(pVar)         '
    $ifndef _LVS_Byte14           '
    $define _LVS_Byte14           '
    Dim LVS_Byte14 As Byte System '
    $endif                        '
    Dim pVar As LVS_Byte14   

$define LocalByte15(pVar)         '
    $ifndef _LVS_Byte15           '
    $define _LVS_Byte15           '
    Dim LVS_Byte15 As Byte System '
    $endif                        '
    Dim pVar As LVS_Byte15   
    
                    
'-------------------------------------------------------------------------------
' Declare Local Words Variables System
$define LocalWord0(pVar)         '
    $ifndef _LVS_Word0           '
    $define _LVS_Word0           '
    Dim LVS_Word0 As Word System '
    $endif                       '
    Dim pVar As LVS_Word0

$define LocalWord1(pVar)         '
    $ifndef _LVS_Word1           '
    $define _LVS_Word1           '
    Dim LVS_Word1 As Word System '
    $endif                       '
    Dim pVar As LVS_Word1

$define LocalWord2(pVar)         '
    $ifndef _LVS_Word2           '
    $define _LVS_Word2           '
    Dim LVS_Word2 As Word System '
    $endif                       '
    Dim pVar As LVS_Word2

$define LocalWord3(pVar)         '
    $ifndef _LVS_Word3           '
    $define _LVS_Word3           '
    Dim LVS_Word3 As Word System '
    $endif                       '
    Dim pVar As LVS_Word3

$define LocalWord4(pVar)         '
    $ifndef _LVS_Word4           '
    $define _LVS_Word4           '
    Dim LVS_Word4 As Word System '
    $endif                       '
    Dim pVar As LVS_Word4

$define LocalWord5(pVar)         '
    $ifndef _LVS_Word5           '
    $define _LVS_Word5           '
    Dim LVS_Word5 As Word System '
    $endif                       '
    Dim pVar As LVS_Word5

$define LocalWord6(pVar)         '
    $ifndef _LVS_Word6           '
    $define _LVS_Word6           '
    Dim LVS_Word6 As Word System '
    $endif                       '
    Dim pVar As LVS_Word6

$define LocalWord7(pVar)         '
    $ifndef _LVS_Word7           '
    $define _LVS_Word7           '
    Dim LVS_Word7 As Word System '
    $endif                       '
    Dim pVar As LVS_Word7

'-------------------------------------------------------------------------------
' Declare Local Dwords Variables System
$define LocalDword0(pVar)          '
    $ifndef _LVS_Dword0            '
    $define _LVS_Dword0            '
    Dim LVS_Dword0 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword0
    
$define LocalDword1(pVar)          '
    $ifndef _LVS_Dword1            '
    $define _LVS_Dword1            '
    Dim LVS_Dword1 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword1

$define LocalDword2(pVar)          '
    $ifndef _LVS_Dword2            '
    $define _LVS_Dword2            '
    Dim LVS_Dword2 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword2

$define LocalDword3(pVar)          '
    $ifndef _LVS_Dword3            '
    $define _LVS_Dword3            '
    Dim LVS_Dword3 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword3

$define LocalDword4(pVar)          '
    $ifndef _LVS_Dword4            '
    $define _LVS_Dword4            '
    Dim LVS_Dword4 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword4

$define LocalDword5(pVar)          '
    $ifndef _LVS_Dword5            '
    $define _LVS_Dword5            '
    Dim LVS_Dword5 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword5

$define LocalDword6(pVar)          '
    $ifndef _LVS_Dword6            '
    $define _LVS_Dword6            '
    Dim LVS_Dword6 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword6

$define LocalDword7(pVar)          '
    $ifndef _LVS_Dword7            '
    $define _LVS_Dword7            '
    Dim LVS_Dword7 As Dword System '
    $endif                         '
    Dim pVar As LVS_Dword7

'-------------------------------------------------------------------------------
' Declare Local Float Variables System
$define LocalFloat0(pVar)          '
    $ifndef _LVS_Float0            '
    $define _LVS_Float0            '
    Dim LVS_Float0 As Float System '
    $endif                         '
    Dim pVar As LVS_Float0

$define LocalFloat1(pVar)          '
    $ifndef _LVS_Float1            '
    $define _LVS_Float1            '
    Dim LVS_Float1 As Float System '
    $endif                         '
    Dim pVar As LVS_Float1

$define LocalFloat2(pVar)          '
    $ifndef _LVS_Float2            '
    $define _LVS_Float2            '
    Dim LVS_Float2 As Float System '
    $endif                         '
    Dim pVar As LVS_Float2

$define LocalFloat3(pVar)          '
    $ifndef _LVS_Float3            '
    $define _LVS_Float3            '
    Dim LVS_Float3 As Float System '
    $endif                         '
    Dim pVar As LVS_Float3

$define LocalFloat4(pVar)          '
    $ifndef _LVS_Float4            '
    $define _LVS_Float4            '
    Dim LVS_Float4 As Float System '
    $endif                         '
    Dim pVar As LVS_Float4

$define LocalFloat5(pVar)          '
    $ifndef _LVS_Float5            '
    $define _LVS_Float5            '
    Dim LVS_Float5 As Float System '
    $endif                         '
    Dim pVar As LVS_Float5

$define LocalFloat6(pVar)          '
    $ifndef _LVS_Float6            '
    $define _LVS_Float6            '
    Dim LVS_Float6 As Float System '
    $endif                         '
    Dim pVar As LVS_Float6

$define LocalFloat7(pVar)          '
    $ifndef _LVS_Float7            '
    $define _LVS_Float7            '
    Dim LVS_Float7 As Float System '
    $endif                         '
    Dim pVar As LVS_Float7
   
$define LocalFloat8(pVar)          '
    $ifndef _LVS_Float8            '
    $define _LVS_Float8            '
    Dim LVS_Float8 As Float System '
    $endif                         '
    Dim pVar As LVS_Float8
    
$define LocalFloat9(pVar)          '
    $ifndef _LVS_Float9            '
    $define _LVS_Float9            '
    Dim LVS_Float9 As Float System '
    $endif                         '
    Dim pVar As LVS_Float9

$define LocalFloat10(pVar)          '
    $ifndef _LVS_Float10            '
    $define _LVS_Float10            '
    Dim LVS_Float10 As Float System '
    $endif                          '
    Dim pVar As LVS_Float10

$define LocalFloat11(pVar)          '
    $ifndef _LVS_Float11            '
    $define _LVS_Float11            '
    Dim LVS_Float11 As Float System '
    $endif                          '
    Dim pVar As LVS_Float11

$define LocalFloat12(pVar)          '
    $ifndef _LVS_Float12            '
    $define _LVS_Float12            '
    Dim LVS_Float12 As Float System '
    $endif                          '
    Dim pVar As LVS_Float12

$define LocalFloat13(pVar)          '
    $ifndef _LVS_Float13            '
    $define _LVS_Float13            '
    Dim LVS_Float13 As Float System '
    $endif                          '
    Dim pVar As LVS_Float13

$define LocalFloat14(pVar)          '
    $ifndef _LVS_Float14            '
    $define _LVS_Float14            '
    Dim LVS_Float14 As Float System '
    $endif                          '
    Dim pVar As LVS_Float14

$define LocalFloat15(pVar)          '
    $ifndef _LVS_Float15            '
    $define _LVS_Float15            '
    Dim LVS_Float15 As Float System '
    $endif                          '
    Dim pVar As LVS_Float15
                            
'-------------------------------------------------------------------------------
' Declare Local Bits Variables System
$define LocalBit0(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.0
        
$define LocalBit1(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.1
    
$define LocalBit2(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.2
    
$define LocalBit3(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.3    
        
$define LocalBit4(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.4
    
$define LocalBit5(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.5
    
$define LocalBit6(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.6    
            
$define LocalBit7(pVar)          '
    $ifndef _LVS_BitsA           '
    $define _LVS_BitsA           '
    Dim LVS_BitsA As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsA.7

$define LocalBit8(pVar)          '
    $ifndef _LVS_BitsB           '
    $define _LVS_BitsB           '
    Dim LVS_BitsB As Byte System '
    $endif                       '
    Dim pVar As LVS_BitsB.0

' etc...    
'-------------------------------------------------------------------------------
' Declare Local SBytes Variables System
$define LocalSByte0(pVar)          '    
    $ifndef _LVS_SByte0            '
    $define _LVS_SByte0            '
    Dim LVS_SByte0 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte0

$define LocalSByte1(pVar)          '  
    $ifndef _LVS_SByte1            '
    $define _LVS_SByte1            '
    Dim LVS_SByte1 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte1

$define LocalSByte2(pVar)          '  
    $ifndef _LVS_SByte2            '
    $define _LVS_SByte2            '
    Dim LVS_SByte2 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte2

$define LocalSByte3(pVar)          '  
    $ifndef _LVS_SByte3            '
    $define _LVS_SByte3            '
    Dim LVS_SByte3 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte3

$define LocalSByte4(pVar)          '  
    $ifndef _LVS_SByte4            '
    $define _LVS_SByte4            '
    Dim LVS_SByte4 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte4

$define LocalSByte5(pVar)          '  
    $ifndef _LVS_SByte5            '
    $define _LVS_SByte5            '
    Dim LVS_SByte5 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte5

$define LocalSByte6(pVar)          '  
    $ifndef _LVS_SByte6            '
    $define _LVS_SByte6            '
    Dim LVS_SByte6 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte6

$define LocalSByte7(pVar)          '  
    $ifndef _LVS_SByte7            '
    $define _LVS_SByte7            '
    Dim LVS_SByte7 As SByte System '
    $endif                         '
    Dim pVar As LVS_SByte7
    
'-------------------------------------------------------------------------------
' Declare Local SWords Variables System
$define LocalSWord0(pVar)          '
    $ifndef _LVS_SWord0            '
    $define _LVS_SWord0            '
    Dim LVS_SWord0 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord0

$define LocalSWord1(pVar)          '
    $ifndef _LVS_SWord1            '
    $define _LVS_SWord1            '
    Dim LVS_SWord1 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord1

$define LocalSWord2(pVar)          '
    $ifndef _LVS_SWord2            '
    $define _LVS_SWord2            '
    Dim LVS_SWord2 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord2

$define LocalSWord3(pVar)          '
    $ifndef _LVS_SWord3            '
    $define _LVS_SWord3            '
    Dim LVS_SWord3 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord3

$define LocalSWord4(pVar)          '
    $ifndef _LVS_SWord4            '
    $define _LVS_SWord4            '
    Dim LVS_SWord4 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord4

$define LocalSWord5(pVar)          '
    $ifndef _LVS_SWord5            '
    $define _LVS_SWord5            '
    Dim LVS_SWord5 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord5

$define LocalSWord6(pVar)          '
    $ifndef _LVS_SWord6            '
    $define _LVS_SWord6            '
    Dim LVS_SWord6 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord6

$define LocalSWord7(pVar)          '
    $ifndef _LVS_SWord7            '
    $define _LVS_SWord7            '
    Dim LVS_SWord7 As SWord System '
    $endif                         '
    Dim pVar As LVS_SWord7
        
'-------------------------------------------------------------------------------
' Declare Local SDWords Variables System
$define LocalSDword0(pVar)           '
    $ifndef _LVS_SDWord0             ' 
    $define _LVS_SDWord0             '
    Dim LVS_SDWord0 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord0

$define LocalSDword1(pVar)           '
    $ifndef _LVS_SDWord1             '
    $define _LVS_SDWord1             '
    Dim LVS_SDWord1 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord1

$define LocalSDword2(pVar)           '
    $ifndef _LVS_SDWord2             '
    $define _LVS_SDWord2             '
    Dim LVS_SDWord2 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord2

$define LocalSDword3(pVar)           '
    $ifndef _LVS_SDWord3             '
    $define _LVS_SDWord3             '
    Dim LVS_SDWord3 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord3

$define LocalSDword4(pVar)           '
    $ifndef _LVS_SDWord4             '
    $define _LVS_SDWord4             '
    Dim LVS_SDWord4 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord4

$define LocalSDword5(pVar)           '
    $ifndef _LVS_SDWord5             '
    $define _LVS_SDWord5             '
    Dim LVS_SDWord5 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord5

$define LocalSDword6(pVar)           '
    $ifndef _LVS_SDWord6             '
    $define _LVS_SDWord6             '
    Dim LVS_SDWord6 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord6

$define LocalSDword7(pVar)           '
    $ifndef _LVS_SDWord7             '
    $define _LVS_SDWord7             '
    Dim LVS_SDWord7 As SDword System '
    $endif                           '
    Dim pVar As LVS_SDWord7
 
        
'===============================================================================
' Local variables for the State Machine. Main Program.

' Declare Local Bytes Variables
$define SMLocalByte0(pVar) '
    $ifndef _SM_Byte0      '
    $define _SM_Byte0      '
    Dim SM_Byte0 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte0

$define SMLocalByte1(pVar) '
    $ifndef _SM_Byte1      '
    $define _SM_Byte1      '
    Dim SM_Byte1 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte1

$define SMLocalByte2(pVar) '
    $ifndef _SM_Byte2      '
    $define _SM_Byte2      '
    Dim SM_Byte2 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte2

$define SMLocalByte3(pVar) '
    $ifndef _SM_Byte3      '
    $define _SM_Byte3      '
    Dim SM_Byte3 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte3

$define SMLocalByte4(pVar) '
    $ifndef _SM_Byte4      '
    $define _SM_Byte4      '
    Dim SM_Byte4 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte4

$define SMLocalByte5(pVar) '
    $ifndef _SM_Byte5      '
    $define _SM_Byte5      '
    Dim SM_Byte5 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte5

$define SMLocalByte6(pVar) '
    $ifndef _SM_Byte6      '
    $define _SM_Byte6      '
    Dim SM_Byte6 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte6

$define SMLocalByte7(pVar) '
    $ifndef _SM_Byte7      '
    $define _SM_Byte7      '
    Dim SM_Byte7 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte7

$define SMLocalByte8(pVar) '
    $ifndef _SM_Byte8      '
    $define _SM_Byte8      '
    Dim SM_Byte8 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte8

$define SMLocalByte9(pVar) '
    $ifndef _SM_Byte9      '
    $define _SM_Byte9      '
    Dim SM_Byte9 As Byte   '
    $endif                 '
    Dim pVar As SM_Byte9
    
$define SMLocalByte10(pVar) '
    $ifndef _SM_Byte10      '
    $define _SM_Byte10      '
    Dim SM_Byte10 As Byte   '
    $endif                  '
    Dim pVar As SM_Byte10    

$define SMLocalByte11(pVar) '
    $ifndef _SM_Byte11      '
    $define _SM_Byte11      '
    Dim SM_Byte11 As Byte   '
    $endif                  '
    Dim pVar As SM_Byte11

$define SMLocalByte12(pVar) '
    $ifndef _SM_Byte12      '
    $define _SM_Byte12      '
    Dim SM_Byte12 As Byte   '
    $endif                  '
    Dim pVar As SM_Byte12
    
$define SMLocalByte13(pVar) '
    $ifndef _SM_Byte13      '
    $define _SM_Byte13      '
    Dim SM_Byte13 As Byte   '
    $endif                  '
    Dim pVar As SM_Byte13    
    
$define SMLocalByte14(pVar) '
    $ifndef _SM_Byte14      '
    $define _SM_Byte14      '
    Dim SM_Byte14 As Byte   '
    $endif                  '
    Dim pVar As SM_Byte14
    
$define SMLocalByte15(pVar) '
    $ifndef _SM_Byte15      '
    $define _SM_Byte15      '
    Dim SM_Byte15 As Byte   '
    $endif                  '
    Dim pVar As SM_Byte15
                
'-------------------------------------------------------------------------------
' Declare Local Words Variables
$define SMLocalWord0(pVar) '
    $ifndef _SM_Word0      '
    $define _SM_Word0      '
    Dim SM_Word0 As Word   '
    $endif                 '
    Dim pVar As SM_Word0

$define SMLocalWord1(pVar) '
    $ifndef _SM_Word1      '
    $define _SM_Word1      '
    Dim SM_Word1 As Word   '
    $endif                 '
    Dim pVar As SM_Word1

$define SMLocalWord2(pVar) '
    $ifndef _SM_Word2      '
    $define _SM_Word2      '
    Dim SM_Word2 As Word   '
    $endif                 '
    Dim pVar As SM_Word2

$define SMLocalWord3(pVar) '
    $ifndef _SM_Word3      '
    $define _SM_Word3      '
    Dim SM_Word3 As Word   '
    $endif                 '
    Dim pVar As SM_Word3

$define SMLocalWord4(pVar) '
    $ifndef _SM_Word4      '
    $define _SM_Word4      '
    Dim SM_Word4 As Word   '
    $endif                 '
    Dim pVar As SM_Word4

$define SMLocalWord5(pVar) '
    $ifndef _SM_Word5      '
    $define _SM_Word5      '
    Dim SM_Word5 As Word   '
    $endif                 '
    Dim pVar As SM_Word5

$define SMLocalWord6(pVar) '
    $ifndef _SM_Word6      '
    $define _SM_Word6      '
    Dim SM_Word6 As Word   '
    $endif                 '
    Dim pVar As SM_Word6

$define SMLocalWord7(pVar) '
    $ifndef _SM_Word7      '
    $define _SM_Word7      '
    Dim SM_Word7 As Word   '
    $endif                 '
    Dim pVar As SM_Word7
        
'-------------------------------------------------------------------------------
' Declare Local Dwords Variables
$define SMLocalDword0(pVar) '
    $ifndef _SM_Dword0      '
    $define _SM_Dword0      '
    Dim SM_Dword0 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword0

$define SMLocalDword1(pVar) '
    $ifndef _SM_Dword1      '
    $define _SM_Dword1      '
    Dim SM_Dword1 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword1

$define SMLocalDword2(pVar) '
    $ifndef _SM_Dword2      '
    $define _SM_Dword2      '
    Dim SM_Dword2 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword2

$define SMLocalDword3(pVar) '
    $ifndef _SM_Dword3      '
    $define _SM_Dword3      '
    Dim SM_Dword3 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword3

$define SMLocalDword4(pVar) '
    $ifndef _SM_Dword4      '
    $define _SM_Dword4      '
    Dim SM_Dword4 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword4

$define SMLocalDword5(pVar) '
    $ifndef _SM_Dword5      '
    $define _SM_Dword5      '
    Dim SM_Dword5 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword5

$define SMLocalDword6(pVar) '
    $ifndef _SM_Dword6      '
    $define _SM_Dword6      '
    Dim SM_Dword6 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword6

$define SMLocalDword7(pVar) '
    $ifndef _SM_Dword7      '
    $define _SM_Dword7      '
    Dim SM_Dword7 As Dword  '
    $endif                  '
    Dim pVar As SM_Dword7

'-------------------------------------------------------------------------------
' Declare Local Float Variables
$define SMLocalFloat0(pVar) '
    $ifndef _SM_Float0      '
    $define _SM_Float0      '
    Dim SM_Float0 As Float  '
    $endif                  '
    Dim pVar As SM_Float0

$define SMLocalFloat1(pVar) '
    $ifndef _SM_Float1      '
    $define _SM_Float1      '
    Dim SM_Float1 As Float  '
    $endif                  '
    Dim pVar As SM_Float1

$define SMLocalFloat2(pVar) '
    $ifndef _SM_Float2      '
    $define _SM_Float2      '
    Dim SM_Float2 As Float  '
    $endif                  '
    Dim pVar As SM_Float2

$define SMLocalFloat3(pVar) '
    $ifndef _SM_Float3      '
    $define _SM_Float3      '
    Dim SM_Float3 As Float  '
    $endif                  '
    Dim pVar As SM_Float3

$define SMLocalFloat4(pVar) '
    $ifndef _SM_Float4      '
    $define _SM_Float4      '
    Dim SM_Float4 As Float  '
    $endif                  '
    Dim pVar As SM_Float4

$define SMLocalFloat5(pVar) '
    $ifndef _SM_Float5      '
    $define _SM_Float5      '
    Dim SM_Float5 As Float  '
    $endif                  '
    Dim pVar As SM_Float5

$define SMLocalFloat6(pVar) '
    $ifndef _SM_Float6      '
    $define _SM_Float6      '
    Dim SM_Float6 As Float  '
    $endif                  '
    Dim pVar As SM_Float6

$define SMLocalFloat7(pVar) '
    $ifndef _SM_Float7      '
    $define _SM_Float7      '
    Dim SM_Float7 As Float  '
    $endif                  '
    Dim pVar As SM_Float7

$define SMLocalFloat8(pVar) '
    $ifndef _SM_Float8      '
    $define _SM_Float8      '
    Dim SM_Float8 As Float  '
    $endif                  '
    Dim pVar As SM_Float8

$define SMLocalFloat9(pVar) '
    $ifndef _SM_Float9      '
    $define _SM_Float9      '
    Dim SM_Float9 As Float  '
    $endif                  '
    Dim pVar As SM_Float9

$define SMLocalFloat10(pVar) '
    $ifndef _SM_Float10      '
    $define _SM_Float10      '
    Dim SM_Float10 As Float  '
    $endif                   '
    Dim pVar As SM_Float10

$define SMLocalFloat11(pVar) '
    $ifndef _SM_Float11      '
    $define _SM_Float11      '
    Dim SM_Float11 As Float  '
    $endif                   '
    Dim pVar As SM_Float11

$define SMLocalFloat12(pVar) '
    $ifndef _SM_Float12      '
    $define _SM_Float12      '
    Dim SM_Float12 As Float  '
    $endif                   '
    Dim pVar As SM_Float12
    
$define SMLocalFloat13(pVar) '
    $ifndef _SM_Float13      '
    $define _SM_Float13      '
    Dim SM_Float13 As Float  '
    $endif                   '
    Dim pVar As SM_Float13
    
$define SMLocalFloat14(pVar) '
    $ifndef _SM_Float14      '
    $define _SM_Float14      '
    Dim SM_Float14 As Float  '
    $endif                   '
    Dim pVar As SM_Float14
    
$define SMLocalFloat15(pVar) '
    $ifndef _SM_Float15      '
    $define _SM_Float15      '
    Dim SM_Float15 As Float  '
    $endif                   '
    Dim pVar As SM_Float15
    
$define SMLocalFloat16(pVar) '
    $ifndef _SM_Float16      '
    $define _SM_Float16      '
    Dim SM_Float16 As Float  '
    $endif                   '
    Dim pVar As SM_Float16
    
$define SMLocalFloat17(pVar) '
    $ifndef _SM_Float17      '
    $define _SM_Float17      '
    Dim SM_Float17 As Float  '
    $endif                   '
    Dim pVar As SM_Float17    
        
$define SMLocalFloat18(pVar) '
    $ifndef _SM_Float18      '
    $define _SM_Float18      '
    Dim SM_Float18 As Float  '
    $endif                   '
    Dim pVar As SM_Float18    
        
$define SMLocalFloat19(pVar) '
    $ifndef _SM_Float19      '
    $define _SM_Float19      '
    Dim SM_Float19 As Float  '
    $endif                   '
    Dim pVar As SM_Float19
    
$define SMLocalFloat20(pVar) '
    $ifndef _SM_Float20      '
    $define _SM_Float20      '
    Dim SM_Float20 As Float  '
    $endif                   '
    Dim pVar As SM_Float20
    
$define SMLocalFloat21(pVar) '
    $ifndef _SM_Float21      '
    $define _SM_Float21      '
    Dim SM_Float21 As Float  '
    $endif                   '
    Dim pVar As SM_Float21  
    
$define SMLocalFloat22(pVar) '
    $ifndef _SM_Float22      '
    $define _SM_Float22      '
    Dim SM_Float22 As Float  '
    $endif                   '
    Dim pVar As SM_Float22        
    
$define SMLocalFloat23(pVar) '
    $ifndef _SM_Float23      '
    $define _SM_Float23      '
    Dim SM_Float23 As Float  '
    $endif                   '
    Dim pVar As SM_Float23    
        
$define SMLocalFloat24(pVar) '
    $ifndef _SM_Float24      '
    $define _SM_Float24      '
    Dim SM_Float24 As Float  '
    $endif                   '
    Dim pVar As SM_Float24        
    
$define SMLocalFloat25(pVar) '
    $ifndef _SM_Float25      '
    $define _SM_Float25      '
    Dim SM_Float25 As Float  '
    $endif                   '
    Dim pVar As SM_Float25    
                
'-------------------------------------------------------------------------------
' Declare Local Bits Variables
$define SMLocalBit0(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.0

$define SMLocalBit1(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.1

$define SMLocalBit2(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.2

$define SMLocalBit3(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.3
    
$define SMLocalBit4(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.4    
    
$define SMLocalBit5(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.5    
    
$define SMLocalBit6(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.6

$define SMLocalBit7(pVar)  '
    $ifndef _SM_BitsA      '
    $define _SM_BitsA      '
    Dim SM_BitsA As Byte   '
    $endif                 '
    Dim pVar As SM_BitsA.7

$define SMLocalBit8(pVar)  '
    $ifndef _SM_BitsB      '
    $define _SM_BitsB      '
    Dim SM_BitsV As Byte   '
    $endif                 '
    Dim pVar As SM_BitsB.0

' Etc...            
'-------------------------------------------------------------------------------
' Declare Local SBytes Variables
$define SMLocalSByte0(pVar) '    
    $ifndef _SM_SByte0      '
    $define _SM_SByte0      '
    Dim SM_SByte0 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte0

$define SMLocalSByte1(pVar) '
    $ifndef _SM_SByte1      '
    $define _SM_SByte1      '
    Dim SM_SByte1 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte1

$define SMLocalSByte2(pVar) '
    $ifndef _SM_SByte2      '
    $define _SM_SByte2      '
    Dim SM_SByte2 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte2

$define SMLocalSByte3(pVar) '
    $ifndef _SM_SByte3      '
    $define _SM_SByte3      '
    Dim SM_SByte3 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte3

$define SMLocalSByte4(pVar) '
    $ifndef _SM_SByte4      '
    $define _SM_SByte4      '
    Dim SM_SByte4 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte4

$define SMLocalSByte5(pVar) '
    $ifndef _SM_SByte5      '
    $define _SM_SByte5      '
    Dim SM_SByte5 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte5

$define SMLocalSByte6(pVar) '
    $ifndef _SM_SByte6      '
    $define _SM_SByte6      '
    Dim SM_SByte6 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte6

$define SMLocalSByte7(pVar) '
    $ifndef _SM_SByte7      '
    $define _SM_SByte7      '
    Dim SM_SByte7 As SByte  '
    $endif                  '
    Dim pVar As SM_SByte7
    
'-------------------------------------------------------------------------------
' Declare Local SWords Variables
$define SMLocalSWord0(pVar) '
    $ifndef _SM_SWord0      '
    $define _SM_SWord0      '
    Dim SM_SWord0 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord0

$define SMLocalSWord1(pVar) '
    $ifndef _SM_SWord1      '
    $define _SM_SWord1      '
    Dim SM_SWord1 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord1

$define SMLocalSWord2(pVar) '
    $ifndef _SM_SWord2      '
    $define _SM_SWord2      '
    Dim SM_SWord2 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord2

$define SMLocalSWord3(pVar) '
    $ifndef _SM_SWord3      '
    $define _SM_SWord3      '
    Dim SM_SWord3 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord3

$define SMLocalSWord4(pVar) '
    $ifndef _SM_SWord4      '
    $define _SM_SWord4      '
    Dim SM_SWord4 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord4

$define SMLocalSWord5(pVar) '
    $ifndef _SM_SWord5      '
    $define _SM_SWord5      '
    Dim SM_SWord5 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord5

$define SMLocalSWord6(pVar) '
    $ifndef _SM_SWord6      '
    $define _SM_SWord6      '
    Dim SM_SWord6 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord6

$define SMLocalSWord7(pVar) '
    $ifndef _SM_SWord7      '
    $define _SM_SWord7      '
    Dim SM_SWord7 As SWord  '
    $endif                  '
    Dim pVar As SM_SWord7
        
'-------------------------------------------------------------------------------
' Declare Local SDWords Variables
$define SMLocalSDword0(pVar) '
    $ifndef _SM_SDWord0      '
    $define _SM_SDWord0      '
    Dim SM_SDWord0 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord0

$define SMLocalSDword1(pVar) '
    $ifndef _SM_SDWord1      '
    $define _SM_SDWord1      '
    Dim SM_SDWord1 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord1

$define SMLocalSDword2(pVar) '
    $ifndef _SM_SDWord2      '
    $define _SM_SDWord2      '
    Dim SM_SDWord2 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord2

$define SMLocalSDword3(pVar) '
    $ifndef _SM_SDWord3      '
    $define _SM_SDWord3      '
    Dim SM_SDWord3 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord3

$define SMLocalSDword4(pVar) '
    $ifndef _SM_SDWord4      '
    $define _SM_SDWord4      '
    Dim SM_SDWord4 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord4

$define SMLocalSDword5(pVar) '
    $ifndef _SM_SDWord5      '
    $define _SM_SDWord5      '
    Dim SM_SDWord5 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord5

$define SMLocalSDword6(pVar) '
    $ifndef _SM_SDWord6      '
    $define _SM_SDWord6      '
    Dim SM_SDWord6 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord6

$define SMLocalSDword7(pVar) '
    $ifndef _SM_SDWord7      '
    $define _SM_SDWord7      '
    Dim SM_SDWord7 As SDword '
    $endif                   '
    Dim pVar As SM_SDWord7
    
'===============================================================================
$define SMGlobal_FSR0_Save()     '
    $ifndef FSR0_Save_Var        '
    $define FSR0_Save_Var        '
    Dim FSR0_Save As Word System '
    $endif

$define SMGlobal_FSR1_Save()     '
    $ifndef FSR1_Save_Var        '
    $define FSR1_Save_Var        '
    Dim FSR1_Save As Word System '
    $endif 

$define SMGlobal_FSR2_Save()     '
    $ifndef FSR2_Save_Var        '
    $define FSR2_Save_Var        '
    Dim FSR2_Save As Word System '
    $endif

$ifndef FSR0_Var
    $define FSR0_Var
	Dim FSR0 As FSR0L.Word         'Combine FSR0L\H into a single 16-bit register
$endif
$ifndef FSR1_Var
    $define FSR1_Var
	Dim FSR1 As FSR1L.Word         'Combine FSR0L\H into a single 16-bit register
$endif
$ifndef FSR1_Var
    $define FSR1_Var
	Dim FSR2 As FSR2L.Word         'Combine FSR0L\H into a single 16-bit register
$endif

$ifndef TBLPTR_Var
    $define TBLPTR_Var
	Dim TBLPTR As TBLPTRL.Word     'Combine TBLPTRL\H into a single 16-bit register
$endif
    
'-------------------------------------------------------------------------------
$endif    
'===============================================================================
